\ ADC

hex

portf 3 bit: VCP

: adcinit ( -- )
   83 ( %1000 0011)  ADCSRA c!
   \ ADCSRA = (1<<ADEN)bit7 | (1<<ADPS1)bit1 | (1<<ADPS0)bit0;
   \ set ADC prescaler to , 1MHz / 8 = 125kHz 
   \ ADCSRB = dont care, is not selected   
   FF DIDR0 c!  \ Digital Input Disable Register0
   VCP is_output ;

\ start adc for channel x 
: #adc{ ( x -- ) \  external AREF and ADCx
   adcinit ADMUX c! 
   VCP on
   ADEN on ;

\ stop adc
: }adc ( -- )
   ADEN off
   VCP off ;

\ Conversion is complete on ADIF=1 
: adif? ( -- f )
   ADIF  ( -- adr mask) 
   swap c@ over and = ; 

\ get value
:  adc@ ( -- n )
   ADCL c@ ADCH c@ pack ;

\ do single conversion
: adc ( -- n )
   ADSC on
   begin adif? until
   adc@ ;

\ : adc8 ( x -- n )
\   adc
\   8 0 do adc + 2/ loop  ;

  
\ Test
: t. ( x -- )
   #adc{    
   begin adc . 0D emit key? until
   }adc ;

: light ( -- )
   2 t. ;

: temp ( -- )
   0 t. ;
  

\ finis

