hex

: marker ( c<chars> -- )
    head e@
    dp   e@
    edp  e@
    heap e@
    create , , , ,
    does>
    dup i@ heap e!
    1+ dup i@ edp  e!
    1+ dup i@ dp   e!
    1+ i@ head e! ;

: postpone ( -- ) \ 'ccc'
  bl word find dup 0<
  if drop compile compile , exit then
  if , exit then
  drop [ base @ decimal ] -13 throw [ base ! ] ; immediate

\ dump flash content
: idump ( addr len -- )
    0 do 
    i over +  dup u. i@ u. cr
    loop drop ;

\ dump ram content
: dump ( addr len -- )
    0 do
    i over +  dup u. c@ u. cr
    loop drop ;

: %% 2 base ! ;
: && decimal ;
: $$ hex ;

hex
\ ports
 31 constant portf
 2B constant portd
 2A constant DDRD

: mask ( m -- bitmask )  \ make a mask for bit # m.
    1 swap lshift ;

: pack ( lo hi -- hilo ) \ packed value
    8 lshift or ;

: unpack ( hilo -- lo hi )
   dup ff and swap 8 rshift ;
   
: bit: ( C: "ccc" adr n  -- ) ( R: -- adr bitmask )
   create mask pack ,
   does> i@ unpack ; \ get packed value

\ Turn a bit on, dont change the others.
: on ( adr bitmask -- )
    over  ( -- adr bitmask adr )
    c@    ( -- adr bitmask value )
    or    ( -- adr new-value)
    swap  ( -- new-value adr)
    c! ;

\ Turn a bit off, dont change the others.
: off ( adr bitmask -- )
    invert ( -- adr bitmask )
    over   ( -- adr bitmask adr )
    c@     ( -- adr bitmask value )
    and    ( -- adr new-value)
    swap   ( -- new-value adr)
    c! ;

\ set bit in data direction register for named pin.
\ intended use: PD5 i_output 
: is_output ( adr bitmask -- )  >r 1- r> on ;
: is_input  ( adr bitmask -- )  >r 1- r> off ;

\ finis  mk1.6.07 22:14
